package com.jianxun.gaudi.common;

import com.github.pagehelper.PageInfo;

import java.io.Serializable;

public class DataResult<T> implements Serializable {

    private static final long serialVersionUID = 1L;

    private T items;// 返回数据

    /*currentPage*/
    private int currentPage;

    /*pageSize*/
    private int pageSize;

    /*totalRows*/
    private int count;

    public static long getSerialVersionUID() {
        return serialVersionUID;
    }

    public T getItems() {
        return items;
    }

    public void setItems(T items) {
        this.items = items;
    }

    public int getCurrentPage() {
        return currentPage;
    }

    public void setCurrentPage(int currentPage) {
        this.currentPage = currentPage;
    }

    public int getPageSize() {
        return pageSize;
    }

    public void setPageSize(int pageSize) {
        this.pageSize = pageSize;
    }

    public int getCount() {
        return count;
    }

    public void setCount(int count) {
        this.count = count;
    }

    public DataResult() {
        super();
    }

    public DataResult(T items) {
        super();
        this.items = items;
    }

    public DataResult(PageInfo<T> pageInfo) {
        super();
        this.items = (T) pageInfo.getList();
        this.currentPage = pageInfo.getPageNum();
        this.pageSize = pageInfo.getPageSize();
        this.count = (int) pageInfo.getTotal();
    }
}
