package com.jianxun.gaudi.utils;

import java.lang.reflect.Type;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonParseException;
import com.google.gson.JsonPrimitive;
import com.google.gson.JsonSerializationContext;
import com.google.gson.JsonSerializer;

/**
 * 
 * @author carl
 *
 */
public class GSONDateUtil implements JsonSerializer<Date>, JsonDeserializer<Date>{
	private static Logger log = LoggerFactory.getLogger(GSONDateUtil.class);
	
	@Override
	public Date deserialize(JsonElement json, Type typeOfT, JsonDeserializationContext context)
			throws JsonParseException {
		// TODO Auto-generated method stub
		SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
		Date date = null;

		try {
			date = sdf.parse(json.getAsJsonPrimitive().getAsString());
		} catch (ParseException e) {
			// TODO Auto-generated catch block
			log.error("GSONDateUtil deserialize error.", e);
		}

		return date;

	}


	@Override
	public JsonElement serialize(Date src, Type typeOfSrc, JsonSerializationContext context) {
		// TODO Auto-generated method stub
		SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        return new JsonPrimitive(sdf.format(src));
	}

}
