package com.jianxun.gaudi;

import org.mybatis.spring.annotation.MapperScan;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.context.ApplicationContext;
import org.springframework.context.annotation.Bean;
import org.springframework.data.redis.connection.RedisConnectionFactory;
import org.springframework.data.redis.core.StringRedisTemplate;
import org.springframework.scheduling.annotation.EnableAsync;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.transaction.annotation.EnableTransactionManagement;

@SpringBootApplication
@EnableTransactionManagement
@MapperScan("com.jianxun.gaudi.*.dao")
@EnableScheduling
@EnableAsync
public class GaudiServiceApplication 
{
	@Bean
	StringRedisTemplate template(RedisConnectionFactory connectionFactory) {
		StringRedisTemplate redisTemp = new StringRedisTemplate(connectionFactory);

		return redisTemp;
	}
	
    public static void main( String[] args ) {
    	ApplicationContext ctx = 
    	SpringApplication.run(GaudiServiceApplication.class, args);
    	
    	ctx.getBean(StringRedisTemplate.class);
    }
}
