package com.jianxun.gaudi.cp.dao;

import com.jianxun.gaudi.common.base.MyBatisBaseDao;
import com.jianxun.gaudi.common.vo.StatisticParam;
import com.jianxun.gaudi.common.vo.StatisticVo;
import com.jianxun.gaudi.cp.model.CpComment;
import com.jianxun.gaudi.cp.model.CpCommentExample;
import com.jianxun.gaudi.cp.vo.CpCommentAppVO;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.util.Date;
import java.util.List;

/**
 * CpCommentDAO继承基类
 */
@Repository
public interface CpCommentDAO extends MyBatisBaseDao<CpComment, Integer, CpCommentExample> {

    List<CpCommentAppVO> selectCpCommentApp(@Param("list")List<String> list, @Param("projectId")String projectId,
                                            @Param("type")Integer type);

    CpComment selectCpCommentDetailApp(@Param("commentId")String commentId);

    Integer getCommentAmount(List<String> projectId);

    List<CpComment> selectCpComment(@Param("list")List<String> list, @Param("id")Integer id,
                         @Param("commentId")String commentId, @Param("projectId")String projectId,
                         @Param("type")Integer type, @Param("createStartTime")Date createStartTime,
                         @Param("createEndTime")Date createEndTime, @Param("phone")String phone,
                         @Param("replyStartTime")Date replyStartTime, @Param("replyEndTime")Date replyEndTime,
                         @Param("status")Integer status, @Param("replyName")String replyName);

    List<StatisticVo> getStatisticalData(StatisticParam param);
}