package com.jianxun.gaudi.cp.service;

import com.github.pagehelper.PageInfo;
import com.jianxun.gaudi.common.vo.StatisticParam;
import com.jianxun.gaudi.common.vo.StatisticVo;
import com.jianxun.gaudi.cp.model.CpComment;
import com.jianxun.gaudi.cp.vo.CpCommentAppVO;
import com.jianxun.gaudi.cp.vo.CpCommentFromVO;

import java.util.List;

public interface CpCommentService {

    /**
     * 创建表扬投诉
     * @param token
     * @param cpComment
     */
    void createCpComment(String token, CpComment cpComment);

    /**
     * 获取表扬投诉Web
     * @param token
     * @param cpCommentFromVO
     * @return
     */
    PageInfo<CpComment> getCpComment(String token, CpCommentFromVO cpCommentFromVO);

    /**
     * 获取表扬投诉列表App
     * @param token
     * @param cpCommentFromVO
     * @return
     */
    PageInfo<CpCommentAppVO> getCpCommentApp(String token, CpCommentFromVO cpCommentFromVO);

    /**
     * 获取表扬投诉详细App
     * @param token
     * @param cpCommentFromVO
     * @return
     */
    CpComment getCpCommentDetailApp(String token, CpCommentFromVO cpCommentFromVO);

    /**
     * 获取表扬投诉微信
     * @param token
     * @param cpCommentFromVO
     * @return
     */
    PageInfo<CpComment> getCpCommentWX(String token, CpCommentFromVO cpCommentFromVO);

    /**
     * 获取待回复数量
     * @param token
     * @return
     */
    Integer getCommentAmount(String token);

    /**
     * 获取统计数据
     * @param param
     * @return
     */
    List<StatisticVo> getStatisticalData(StatisticParam param);
}
