package com.jianxun.gaudi.cp.service.impl;

import com.jianxun.gaudi.common.enums.ExceptionMsg;
import com.jianxun.gaudi.common.exception.MyException;
import com.jianxun.gaudi.common.utils.RedisTokenUtil;
import com.jianxun.gaudi.common.vo.RedisVO;
import com.jianxun.gaudi.cp.dao.CpCommentDAO;
import com.jianxun.gaudi.cp.dao.CpReplyDAO;
import com.jianxun.gaudi.cp.model.CpComment;
import com.jianxun.gaudi.cp.model.CpCommentExample;
import com.jianxun.gaudi.cp.model.CpReply;
import com.jianxun.gaudi.cp.model.CpReplyExample;
import com.jianxun.gaudi.cp.service.CpReplyService;
import com.jianxun.gaudi.cp.vo.UserVO;
import com.jianxun.gaudi.sys.service.SysNumberAssignService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.Date;
import java.util.List;

@Service
@Transactional
public class CpReplyServiceImpl implements CpReplyService {

    @Autowired
    CpCommentDAO cpCommentDAO;

    @Autowired
    CpReplyDAO cpReplyDAO;

    @Autowired
    SysNumberAssignService service;

    @Override
    public void createCpReply(String token, CpReply cpReply) {

        CpReplyExample example = new CpReplyExample();
        CpReplyExample.Criteria criteria = example.createCriteria();
        criteria.andCommentIdEqualTo(cpReply.getCommentId());
        List<CpReply> cpCpReplyList =  cpReplyDAO.selectByExample(example);
        if(cpCpReplyList.size() > 0) {
            throw new MyException(ExceptionMsg.REPLY_EXIST);
        }

        /**通过token获取用户**/
        RedisVO redisVO = RedisTokenUtil.getInfoByRedis(token);
        UserVO userVO = redisVO.getUserVO();

        String id = service.assignNumber("HF");

        CpReplyExample cpReplyExample = new CpReplyExample();
        cpReplyExample.createCriteria().andReplyIdEqualTo(id);
        List<CpReply> replyList =  cpReplyDAO.selectByExample(cpReplyExample);
        if (replyList.isEmpty()){
            Date now = new Date();
            cpReply.setReplyId(id);
            cpReply.setCreateTime(now);
            cpReply.setCreateBy(userVO.getUserId().toString());
            cpReply.setCreateName(userVO.getUserName());
            cpReplyDAO.insertSelective(cpReply);
        } else {
            throw new MyException(ExceptionMsg.REPLY_ID_DUPLICATION);
        }

        CpCommentExample example1 = new CpCommentExample();
        CpCommentExample.Criteria criteria1 = example1.createCriteria();
        criteria1.andCommentIdEqualTo(cpReply.getCommentId());
        CpComment cpComment = new CpComment();
        cpComment.setStatus(1);
        cpCommentDAO.updateByExampleSelective(cpComment, example1);
    }
}
