package com.jianxun.gaudi.qs.scheduler;

import com.jianxun.gaudi.qs.service.impl.QuestionnaireSurveyServiceImpl;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Async;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.Date;

@Component
public class OverdueOrderTask  {
    private final Logger logger = LoggerFactory.getLogger(getClass());
    @Autowired
    QuestionnaireSurveyServiceImpl questionnaireSurveyService;
    @Scheduled(cron = "0 */1 * * * ?")
    @Async("myAsync")
    public void myJob(){
        logger.info("\n=============\noverdueOrderTask=====>{}--\n===============\n", LocalDateTime.now());
        logger.info("overdueOrderTask/定时开始自动催收-------");
        //任务处理逻辑
        questionnaireSurveyService.delayedOrderTask();
        logger.info("overdueOrderTask/定时结束自动催收-------");

    }

}
