package com.jianxun.gaudi.qs.service;

import java.util.List;

import com.github.pagehelper.PageInfo;
import com.jianxun.gaudi.common.vo.StatisticParam;
import com.jianxun.gaudi.common.vo.StatisticSumVo;
import com.jianxun.gaudi.common.vo.StatisticVo;
import com.jianxun.gaudi.qs.model.QsAnswer;
import com.jianxun.gaudi.qs.param.*;
import com.jianxun.gaudi.qs.vo.*;
import com.jianxun.gaudi.utils.Pager;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public interface QuestionnaireSurveyService {
    /**
     * 获取跳转管理页面
     *
     * @param token
     * @return
     */
    ManagerVO getManager(String token) throws Exception;

    /**
     * 待参与列表
     *
     * @param token
     * @return
     */
    List<QuestionairesVO> lstToFill(String token) throws Exception;


    /**
     * 待参与列表
     *
     * @param param
     * @return
     */
    List<QuestionairesVO> getQuestionnaire(QsUserParam param) throws Exception;

    /**
     * 已参与列表
     *
     * @param token
     * @return
     */
    List<QuestionairesVO> lstFilled(String token) throws Exception;

    /**
     * 问卷星数据推送回调方法
     *
     * @throws Exception
     */
    void callBack(QsAnswer qsAnswer) throws Exception;

    /**
     * 获取问卷答案链接
     *
     * @param token
     * @param questionairesVO
     * @return
     * @throws Exception
     */
    QsAnswerVO getAnswerUrl(String token, QuestionairesVO questionairesVO) throws Exception;


    /**
     * 获取问卷答案链接
     *
     * @param
     * @param qsQuestionnaireParam
     * @return
     * @throws Exception
     */
    void addQuestionnaire(QsQuestionnaireParam qsQuestionnaireParam) throws Exception;

    /**
     * 问卷设置处理
     *
     * @param
     * @param qsQuestionnaireSettingParam
     * @return
     * @throws Exception
     */
    void sendSettings(QsQuestionnaireSettingParam qsQuestionnaireSettingParam) throws Exception;

    /**
     * 修改用户问卷状态
     *
     * @param
     * @param userId
     * @return
     * @throws Exception
     */
    void modifyQuestionnaireUser(Integer userId)throws Exception;

    /**
     * 问卷设置处理
     *
     * @param
     * @param param
     * @return
     * @throws Exception
     */
    void questionnaireReminder(QsQuestionnaireUrgeParam param) throws Exception;

    /**
     * 查询发送设置
     * @param
     * @param orgId
     * @return
     * @throws Exception
     */
    QsQuestionnaireSettingVO queryQuestionnaireSettings(Integer orgId)throws Exception;

    /**
     * 获取问卷发布列表
     *
     * @param
     * @param param
     * @return
     * @throws Exception
     */
    PageInfo<QsQuestionnaireVO> getQuestionnaireInformation(QuestionnaireInquiryParam param) throws Exception;


    /**
     * 问卷发送详情
     *
     * @param
     * @param
     * @return
     * @throws Exception
     */
    QuestionnaireDetailsVO questionnaireDetails(Integer id) throws Exception;

    /**
     * 问卷进度详情
     *
     * @param
     * @param
     * @return
     * @throws Exception
     */
    List<QsQuestionnaireUserVO> questionnaireProgress(QuestionnaireProgressParam param) throws Exception;


    List<StatisticVo> getStatisticalData(StatisticParam param);

    List<StatisticSumVo> getStatisticalSumData();
}
