package com.jianxun.gaudi.controller.cp;

import com.google.gson.Gson;
import com.jianxun.gaudi.common.ResponseResult;
import com.jianxun.gaudi.common.ResponseResultUtil;
import com.jianxun.gaudi.controller.base.BaseController;
import com.jianxun.gaudi.cp.model.CpReply;
import com.jianxun.gaudi.dubbo.consumer.cp.CpReplyDubboConsumerService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

@RestController
@RequestMapping("/reply")
public class CpReplyController extends BaseController {
    private final Logger logger = LoggerFactory.getLogger(getClass());
    @Autowired
    CpReplyDubboConsumerService service;

    /**
     * 创建回复
     * @param token
     * @param cpReply
     * @return
     */
    @PostMapping("/createCpReply")
    public ResponseResult createCpReply(@RequestHeader("token") String token, @RequestBody CpReply cpReply) {
        logger.info("CpReplyController.createCpReply token:{},cpReply:{}",token, new Gson().toJson(cpReply));
        service.createCpReply(token, cpReply);
        return ResponseResultUtil.createSuccesResult();
    }

}
