package com.jianxun.gaudi.controller.qs;

import com.google.gson.Gson;
import com.jianxun.gaudi.common.ResponseResult;
import com.jianxun.gaudi.common.ResponseResultUtil;
import com.jianxun.gaudi.controller.base.BaseController;
import com.jianxun.gaudi.dubbo.consumer.qs.QuestionnaireSurveyDubboConsumerService;
import com.jianxun.gaudi.qs.vo.ManagerVO;
import com.jianxun.gaudi.qs.vo.QsAnswerVO;
import com.jianxun.gaudi.qs.vo.QuestionairesVO;

import java.util.List;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestHeader;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping({"/qs"})
public class WeQuestionnaireSurveyController extends BaseController {
    private final Logger logger = LoggerFactory.getLogger(getClass());

    @Autowired
    QuestionnaireSurveyDubboConsumerService service;

    @RequestMapping({"/modifyQuestionnaireUser"})
    @ResponseBody
    public ResponseResult<Object> modifyQuestionnaireUser(@RequestParam Integer userId) throws Exception {
        this.logger.info("QuestionnaireSurveyController.modifyQuestionnaireUser userId:{}", userId);
        this.service.modifyQuestionnaireUser(userId);
        return ResponseResultUtil.createSuccesResult();
    }

    @RequestMapping({"/getManager"})
    @ResponseBody
    public ResponseResult<ManagerVO> getManager(@RequestHeader("token") String token) throws Exception {
        this.logger.info("QuestionnaireSurveyController.getManager token:{}", token);
        ResponseResult<ManagerVO> result = new ResponseResult();
        result.setData(this.service.getManager(token));
        return result;
    }

    @RequestMapping({"/lstToFill"})
    @ResponseBody
    public ResponseResult<List<QuestionairesVO>> lstToFill(@RequestHeader("token") String token) throws Exception {
        this.logger.info("QuestionnaireSurveyController.lstToFill token:{}", token);
        ResponseResult<List<QuestionairesVO>> result = new ResponseResult();
        result.setData(this.service.lstToFill(token));
        return result;
    }

    @RequestMapping({"/lstFilled"})
    @ResponseBody
    public ResponseResult<List<QuestionairesVO>> lstFilled(@RequestHeader("token") String token) throws Exception {
        this.logger.info("QuestionnaireSurveyController.lstFilled token:{}", token);
        ResponseResult<List<QuestionairesVO>> result = new ResponseResult();
        result.setData(this.service.lstFilled(token));
        return result;
    }

    @RequestMapping({"/callBack"})
    @ResponseBody
    public ResponseResult<Object> callBack(@RequestBody QsAnswerVO qsAnswerVO) throws Exception {
        this.logger.info("QuestionnaireSurveyController.callBack qsAnswerVO:{}", (new Gson()).toJson(qsAnswerVO));
        this.service.callBack(qsAnswerVO);
        return ResponseResultUtil.createSuccesResult();
    }

    @RequestMapping({"/getAnswerUrl"})
    @ResponseBody
    public ResponseResult<QsAnswerVO> getAnswerUrl(@RequestHeader("token") String token, @RequestBody QuestionairesVO questionairesVO) throws Exception {
        this.logger.info("QuestionnaireSurveyController.getAnswerUrl token:{},questionairesVO:{}", token, (new Gson()).toJson(questionairesVO));
        ResponseResult<QsAnswerVO> result = new ResponseResult();
        result.setData(this.service.getAnswerUrl(token, questionairesVO));
        return result;
    }
}