package com.jianxun.gaudi.controller.sys;

import com.jianxun.gaudi.common.ResponseResult;
import com.jianxun.gaudi.common.ResponseResultUtil;
import com.jianxun.gaudi.controller.base.BaseController;
import com.jianxun.gaudi.dubbo.consumer.sys.SysAuthDubboConsumerService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestHeader;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.HashMap;
import java.util.Map;

@RestController
@RequestMapping("/auth")
public class SysAuthController extends BaseController {
    private final Logger logger = LoggerFactory.getLogger(getClass());
    @Autowired
    SysAuthDubboConsumerService service;

    /**
     * 根据token获得项目数据
     * @param token
     * @return
     */
    @PostMapping("/getOrgsByToken")
    public ResponseResult getOrgsByToken(@RequestHeader("token") String token) {
        logger.info("SysAuthController.getOrgsByToken token:{}",token);
        return ResponseResultUtil.createSuccesResult(service.getOrgsByToken(token));
    }

    /**
     * 根据token获得某人是否有投诉表扬回复权限
     * @param token
     * @return
     */
    @PostMapping("/getUserIsHaveTsbyReplyByToken")
    public ResponseResult getUserIsHaveTsbyReplyByToken(@RequestHeader("token") String token) {
        logger.info("SysAuthController.getUserIsHaveTsbyReplyByToken token:{}",token);
        boolean flag = service.getUserIsHaveTsbyReplyByToken(token);
        Map<String, String> map = new HashMap<>();
        if(flag){
            map.put("haveTsbyReplyPermission", "1");
        }else{
            map.put("haveTsbyReplyPermission", "0");
        }
        return ResponseResultUtil.createSuccesResult(map);
    }
}
