package com.jianxun.gaudi.controller.sys;

import com.jianxun.gaudi.common.ResponseResult;
import com.jianxun.gaudi.common.ResponseResultUtil;
import com.jianxun.gaudi.controller.base.BaseController;
import com.jianxun.gaudi.utils.DateUtils;
import com.jianxun.gaudi.utils.ImgUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestHeader;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;

import javax.servlet.http.HttpServletRequest;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@RestController
@RequestMapping("/file")
public class SysFileController extends BaseController {
    private final Logger logger = LoggerFactory.getLogger(getClass());
    @Value("${file.filepath}")
    private String filePath;

    @Value("${file.url}")
    private String url;

    /**
     * 上传文件
     * @param request
     * @return
     */
    @PostMapping("/uploadFile")
    public ResponseResult uploadFile(@RequestHeader("token") String token, HttpServletRequest request) throws Exception {
        logger.info("SysFileController.uploadFile token:{}",token);
        List<MultipartFile> files =((MultipartHttpServletRequest)request).getFiles("file");

        Map<String, List<String>> map = new HashMap<>();

        List<String> fileList = new ArrayList<>();
        for (MultipartFile file: files) {
            String originalFilename = file.getOriginalFilename();
            int splitter = originalFilename.lastIndexOf(".");
            String suffix = originalFilename.substring(splitter);
            String fileName = DateUtils.getNo(1) + suffix;
            File tempFile = new File(filePath + fileName);
            if (!tempFile.exists()) {
                tempFile.getParentFile().mkdirs();
                BufferedOutputStream buffStream = null;
                try {
                    byte[] bytes = file.getBytes();
                    buffStream = new BufferedOutputStream(new FileOutputStream(tempFile));
                    buffStream.write(bytes);
                    buffStream.close();
                    fileList.add(url + fileName);
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            if(tempFile.length() > (500 * 1024)){
                ImgUtils.compressPic(tempFile);
            }
        }
        map.put("files", fileList);
        return ResponseResultUtil.createSuccesResult(map);
    }
}
