package com.jianxun.gaudi.controller.sys;

import javax.servlet.ServletException;

import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestController;

import com.jianxun.gaudi.common.ResponseResult;
import com.jianxun.gaudi.common.exception.MyException;
import com.jianxun.gaudi.controller.base.BaseController;
import com.jianxun.gaudi.dubbo.consumer.sys.SysUserDubboConsumerService;
import com.jianxun.gaudi.sys.model.SysUser;
import com.jianxun.gaudi.sys.vo.SysUserVO;

@RestController
@RequestMapping("/user")
public class SysUserController extends BaseController{
	private final Logger logger = LoggerFactory.getLogger(getClass());
	@Autowired
	SysUserDubboConsumerService service;
	
	@RequestMapping("/getUser")
	@ResponseBody
	public ResponseResult<SysUser> getUser(String userId) {
		logger.info("SysUserController.getUser userId:{}",userId);
		ResponseResult<SysUser> result = new ResponseResult<>();
		result.setData(service.getUserById(userId));

		return result;
	}
	
	@PostMapping("/login")
	@ResponseBody
	public ResponseResult<SysUserVO> login(String account, String password) throws ServletException, MyException{
		logger.info("SysUserController.login account:{},password:{}",account,password);
		SysUserVO user ;
		ResponseResult<SysUserVO> result = new ResponseResult<SysUserVO>();

		if (StringUtils.isEmpty(account) || StringUtils.isEmpty(password)) {
			result.setMsg("账号或密码为空。");
			return result;
		}

		user = service.login(account, password);
		
		result.setData(user);
		return result;
	}
}
