package com.jianxun.gaudi.dubbo.consumer.cp;

import com.alibaba.dubbo.config.annotation.Reference;
import com.github.pagehelper.PageInfo;
import com.jianxun.gaudi.common.vo.StatisticParam;
import com.jianxun.gaudi.common.vo.StatisticVo;
import com.jianxun.gaudi.cp.dubbo.DubboCpCommentService;
import com.jianxun.gaudi.cp.model.CpComment;
import com.jianxun.gaudi.cp.vo.CpCommentAppVO;
import com.jianxun.gaudi.cp.vo.CpCommentFromVO;
import org.springframework.stereotype.Component;

import java.util.List;

@Component
public class CpCommentDubboConsumerService {

    @Reference(version = "1.0.0",timeout=10000,retries=-1,interfaceClass = DubboCpCommentService.class)
    DubboCpCommentService cpCommentService;

    public void createCpComment(String token, CpComment cpComment) {
        cpCommentService.createCpComment(token, cpComment);
    }

    public PageInfo<CpComment> getCpComment(String token, CpCommentFromVO cpCommentFromVO) {
        return cpCommentService.getCpComment(token, cpCommentFromVO);
    }

    public PageInfo<CpCommentAppVO> getCpCommentApp(String token, CpCommentFromVO cpCommentFromVO) {
        return cpCommentService.getCpCommentApp(token, cpCommentFromVO);
    }

    public CpComment getCpCommentDetailApp(String token, CpCommentFromVO cpCommentFromVO) {
        return cpCommentService.getCpCommentDetailApp(token, cpCommentFromVO);
    }

    public PageInfo<CpComment> getCpCommentWX(String token, CpCommentFromVO cpCommentFromVO) {
        return cpCommentService.getCpCommentWX(token, cpCommentFromVO);
    }

    public Integer getCommentAmount(String token) {
        return cpCommentService.getCommentAmount(token);
    }

    public List<StatisticVo> getStatisticalData(StatisticParam param) {
        return cpCommentService.getStatisticalData(param);
    }
}
