package com.jianxun.gaudi.web.converter;

import java.util.Date;

import org.apache.commons.lang3.StringUtils;
import org.apache.log4j.Logger;
import org.springframework.core.convert.converter.Converter;

import com.jianxun.gaudi.utils.DateHelper;


public class DateConverter implements Converter<String,Date>{
	private static Logger logger = Logger.getLogger(DateConverter.class);
	@Override
	public Date convert(String source) {
		Date date = null;
		try {
			if(StringUtils.isEmpty(source)) {
				return null;
			}
			source = source.trim();
			if(source.length()<12) {
				date = DateHelper.parseToDate(source, DateHelper.CURRENT_DATE);
			}else {
				date = DateHelper.parseToDate(source, DateHelper.DATE_TIME_STRING);
			}
            return date;
        } catch (Exception e) {
        	logger.error("spring mvc 自动类型字符串转日期类型失败！");
        }
        return date;
	}
}
