package com.jianxun.gaudi.web.security;


import com.jianxun.gaudi.common.ResponseErrResult;
import com.jianxun.gaudi.common.enums.ExceptionMsg;
import org.springframework.web.bind.annotation.ExceptionHandler;
import org.springframework.web.bind.annotation.RestControllerAdvice;
import org.springframework.web.context.request.RequestContextHolder;
import org.springframework.web.context.request.ServletRequestAttributes;
import org.springframework.web.multipart.MultipartException;
import org.springframework.web.servlet.mvc.method.annotation.ResponseEntityExceptionHandler;

import javax.servlet.http.HttpServletResponse;

@RestControllerAdvice
public class GlobalExceptionHandler extends ResponseEntityExceptionHandler {

    /**
     * 处理上传异常
     * @param t
     * @return
     */
    @ExceptionHandler(MultipartException.class)
    public ResponseErrResult handleAll(Throwable t) {
        HttpServletResponse response = getResponse();
        response.setHeader("Content-type", "text/html;charset=UTF-8");// 让浏览器用utf8来解析返回的数据
        response.setCharacterEncoding("UTF-8");// 告诉servlet用UTF-8转码，而不是用默认的ISO8859
        ResponseErrResult responseerrResult = new ResponseErrResult();
        responseerrResult.setCode(ExceptionMsg.UPLOAD_EXCEEDS.getCode());
        responseerrResult.setMsg(ExceptionMsg.UPLOAD_EXCEEDS.getMsg());
        return responseerrResult;
    }

    public HttpServletResponse getResponse() {
        HttpServletResponse response = ((ServletRequestAttributes) RequestContextHolder.getRequestAttributes()).getResponse();
        return response;
    }


}
